import pandas as pd
import numpy as np
import sys
'''
@Author: Dikshyant Gautam
email : gautam.dikshyant@gmail.com
This script accepts blastoutput -fmt 6 where own output was defined
The blast files are from Moss beach fasta proteins against S15 fasta proteins and vice-versa
'''
out_1st = sys.argv[1] # Takes the blastoutput -fmt 6  result where query is Moss Beach and ref is S15

out_2nd = sys.argv[2] # Takes the blastoutput -fmt 6  result where query is S15and ref is Moss Beach

# function that takes dataframe, name of a new col and name of two columns of the same dataframe
def f(frame,name,col1,col2):
          frame[name] = frame[col1]/frame[col2]

# function that takes dataframe, name of columns to clip coverage
def f_cov(frame, name):
    frame[name]=frame[name].clip_upper(1)


# creating a dataframe
1st_df = pd.read_csv(out_1st, sep="\t", header=None) 
2nd_df = pd.read_csv(out_2nd, sep="\t", header=None)
# Add headers to 1st and 2nd dataframes
headers = ["query", "ref", "identity", "len",
           "qlen", "rlen", "alength",
           "bit", "e-val"]
1st_df.columns = headers

2nd_df.columns = headers

# Create a new column called norm_bit
f(fwd_results,"norm_bit","bit","qlen")
f(rev_results,"norm_bit","bit","qlen")
# Create a new column called qcov and scov

f(fwd_results,"qcov","alength","qlen")
f(fwd_results,"scov","alength","rlen")
f(rev_results,"qcov","alength","qlen")
f(rev_results,"scov","alength","rlen")

# Clip maximum coverage values at 1.0
f_cov(1st_df,'qcov')
f_cov(1st_df,'scov')
f_cov(2nd_df,'qcov')
f_cov(2nd_df,'scov')
# Merge 1st_df and 2nd_df results
rbbh = pd.merge(1st_df, 2nd_df[['query', 'ref']],
                left_on='ref', right_on='query',
                how='outer')

# keeping only RBH rows 
rbbh = rbbh.loc[rbbh.query_x == rbbh.subject_y]

#taking maximum value in each column by grouping method
rbbh = rbbh.groupby(['query_x', 'subject_x']).max()
