#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
@author: dikshyantgautam
email : gautam.dikshyant@gmail.com
This script function is to find the taxonomy for the top hits of possible Acaryochloris Moss Beach plasmids.
 It groups blastoutput result for where query was the proteins files from contigs after assembly( after prodigal protein prediciton) and database was the nr database of NCBI
The grouping is done on top 5 best hits sorted on the basis of evalue from blastp.
for each proteins from plasmids with top 5 hits there gene id  was used to search into NCBI to obtain the taxonomy name
"""



import os, fnmatch
import pandas as pd
import numpy as np
import requests
from lxml import etree
from lxml import html

col_list = ['geneNbr','geneBankID','c','d','e','f','g','h','i','j','eVal','l']
tup = range(13)
lst = dict(zip(tup,col_list))
path = '/Users/dikshyantgautam/Documents/wes_lab/MB_clean_Aug_2020/non_circ_jared_2nd_round_map/' # assigning the path of the files to a varaible users can replace this path with their path
listOfFiles = os.listdir(path) # listing the path of the files
pattern = "*nr.out"
for entry in listOfFiles:
                if fnmatch.fnmatch(entry, pattern):
                        print (entry)
                        #a = "/Users/dikshyantgautam/Documents/wes_lab/MB_clean_Aug_2020/non_circ_jared_2nd_round_map/" + entry
                        df = pd.read_csv('/Users/dikshyantgautam/Documents/wes_lab/MB_clean_Aug_2020/non_circ_jared_2nd_round_map/' + entry ,delimiter='\t',header=None)
                        #df = pd.read_csv(a ,delimiter='\t',header=None)
                        df.rename(columns=lst,inplace=True)
            
            
            # Drop the unnecessary columns
                        df.drop(['c','d','e','f','g','h','i','j','l'],axis=1,inplace=True)
                        
                        # Changing the column position 
                        cols_to_move = ['geneNbr','geneBankID','eVal']
                        cols = cols_to_move + [col for col in df if col not in cols_to_move]
                        df=df[cols]
                        #------------------------------------********************************-----------------------------------#
                        
                        # Grouping according to the 'gene_nbr' and sort the dataFrame with respect to 'eVal' and get only top 5 result
                        df_result = df.groupby(['geneNbr']).apply(lambda x: x.sort_values(['eVal']).head())
                        
                        #------------------------------------********************************-----------------------------------#
                        #------------- Searching for respective "taxo-name" using GeneID of top 5 gene number ------------------#
                        #------------------------------------********************************-----------------------------------#
                        '''get_results is a function which will search for the respective "taxo-name" using "GeneID" on website 
                            www.ncbi.nlm.nih.gov '''
                        def get_results(search_term):
                            url = "https://www.ncbi.nlm.nih.gov/protein/" +search_term 
                            print (url)
                            #url = "https://www.ncbi.nlm.nih.gov/search/all/?term="+search_term
                            page = requests.get(url)
                            tree = html.fromstring(page.content)
                            gene = tree.xpath('//*[@id="maincontent"]/div/div[5]/div[1]/h1/text()')
                            print (gene)
                            if len(gene) > 0:
                                geneString = gene[0]
                                print (geneString)
                                organismString = geneString[geneString.find("[")+1:geneString.find("]")]
                                print (organismString)
                                return organismString
                            else:
                                print ("null")
                                return ("null")
                                
                        
                        
                        df_result['geneBankID'] = df_result['geneBankID'].astype(str)
                        
                        # Saving the result as "taxo_name" in dataframe
                        df_result['taxo_name'] = df_result['geneBankID'].apply(get_results)
                        print(df_result.head())
                        # rank the gene nbr  based on hits 
                        
                        df_result['z_rank'] = data.groupby(['gene_nbr'])['eVal'].rank(method='dense').astype(int)
                        # calulate the frequency of top 5 positions for each taxon
                        grouped_single = data.groupby(['z_rank','taxo_name']).agg({'taxo_name': ['count']})
                        # just taking single column
                        grouped_single.columns = ['taxo_count']
                        
                        grouped_single = grouped_single.reset_index()
                        print(grouped_single)
                        # writing output files in csv format
                       df_result.to_csv(r'/Users/dikshyantgautam/Documents/wes_lab/MB_clean_Aug_2020/non_circ_jared_2nd_round_map/' + entry + ".csv",sep='\t')
                        
                        
                        
