# Author: Dikshyant Gautam
# gautam.dikshyant@gmail.com
#!/bin/bash
# shell script to blast multiple ref files using multiple query files 
# This script uses a reference proteins files as an argument for $1
# users can replace the path containing ids for their referene files in filedir

filedir='~/acaryo/flye_new_latest_jared/post_pgap_proce/marina_files/id_marina' # path of file
for name in `less $filedir` 
do 
echo $name 
makeblastdb -in ~/acaryo/flye_new_latest_jared/post_pgap_proce/marina_files/$name -parse_seqids -dbtype prot # making database in blast
for line in `cat $1`  # id containing query file names
do  
echo $line  
blastp -db ~/acaryo/flye_new_latest_jared/post_pgap_proce/marina_files/$name -query ~/acaryo/flye_new_latest_jared/post_pgap_proce/amrainavsmb/$line -max_target_seqs 5 -outfmt 6 -out $line-$name.out  
done 
done 
